介绍:
股票问题一共有六道:买卖股票的最佳时机(I,II,III,IV)、含冷冻期、含手续费。本次解析还包括一道面试题:面试题63. 股票的最大利润(即买卖股票的最佳时机I)
股票问题的方法就是 动态规划,因为它包含了重叠子问题,即买卖股票的最佳时机是由之前买或不买的状态决定的,而之前买或不买又由更早的状态决定的…
LeetCode 121 :买卖股票的最佳时机I
给定一个数组,它的第 i 个元素是一支给定股票第 i 天的价格。
如果你最多只允许完成一笔交易(即买入和卖出一支股票一次),设计一个算法来计算你所能获取的最大利润。
注意:你不能在买入股票前卖出股票。
示例 1:
输入: [7,1,5,3,6,4]
输出: 5解释: 在第 2 天(股票价格 = 1)的时候买入,在第 5 天(股票价格 = 6)的时候卖出,最大利润 = 6-1 = 5 。
注意利润不能是 7-1 = 6, 因为卖出价格需要大于买入价格;同时,你不能在买入前卖出股票。
示例 2:
输入: [7,6,4,3,1]
输出: 0
解释: 在这种情况下, 没有交易完成, 所以最大利润为 0。
解题思路:动态规划
动态规划一般分为一维、二维、多维(使用状态压缩),对应形式为 dp(i)、dp(i)(j)、二进制dp(i)(j)。
- 动态规划做题步骤:
- 明确 dp(i) 应该表示什么(二维情况:dp(i)(j));
- 根据 dp(i) 和 dp(i-1)的关系得出状态转移方程;
- 确定初始条件,如 dp(0)。
2. 本题思路
由于,本题这里最多只允许完成一笔交易(即买入和卖出一支股票一次),即一维动态规划思想。用dp[i]表示前 i天的最大利润,因为我们始终要使利润最大化,则:
dp[i] = max(dp[i-1], prices[i]-minprice)
代码实现:
- C++:
class Solution {
public:
int maxProfit(vector<int>& prices) {
int minprice = int(1e9);
int maxprofit = 0;
// auto 关键字,price取遍prices中的元素
for (auto price : prices){
maxprofit = max(maxprofit, price - minprice);
minprice = min(minprice, price);
}
return maxprofit;
}
};
- Python
class Solution:
def maxProfit(self, prices: List[int]) -> int:
if (len(prices)==0):
return 0;
maxprofit,minprice = [0]*len(prices),prices[0]
for i in range(1,len(prices)):
maxprofit[i] = max(maxprofit[i-1],prices[i]-minprice)
minprice = min(prices[i],minprice)
return maxprofit[-1]
LeetCode:122. 买卖股票的最佳时机 II
给定一个数组,它的第 i 个元素是一支给定股票第 i 天的价格。
设计一个算法来计算你所能获取的最大利润。你可以尽可能地完成更多的交易(多次买卖一支股票)。 对于交易次数没有限制
注意:你不能同时参与多笔交易(你必须在再次购买前出售掉之前的股票)。
示例 1:
输入: [7,1,5,3,6,4]
输出: 7解释: 在第 2 天(股票价格 = 1)的时候买入,在第 3 天(股票价格 = 5)的时候卖出, 这笔交易所能获得利润 = 5-1 = 4 。
随后,在第 4 天(股票价格 = 3)的时候买入,在第 5 天(股票价格 = 6)的时候卖出, 这笔交易所能获得利润 = 6-3 = 3 。
示例 2:
输入: [1,2,3,4,5]
输出: 4解释: 在第 1 天(股票价格 = 1)的时候买入,在第 5 天 (股票价格 = 5)的时候卖出, 这笔交易所能获得利润 = 5-1 = 4 。
注意你不能在第 1 天和第 2 天接连购买股票,之后再将它们卖出。因为这样属于同时参与了多笔交易,你必须在再次购买前出售掉之前的股票。
示例 3:
输入: [7,6,4,3,1]
输出: 0
解释: 在这种情况下, 没有交易完成, 所以最大利润为 0。
提示:
1 <= prices.length <= 3 * 10 ^ 4
0 <= prices[i] <= 10 ^ 4
解题思路:由于对于交易次数没有限制,可以每在前一个时刻比下一个时刻价格要小的情况下就进行一次交易,这样总的利润是最大的。如下图所示:
代码实现:
- C++:
class Solution {
public:
int maxProfit(vector<int>& prices) {
int length = prices.size();
int maxProfit = 0;
for(int i=1;i<length;i++){
if(prices[i-1]<prices[i]){
maxProfit+=prices[i]-prices[i-1];
}
}
return maxProfit;
}
};
- Python:
class Solution:
def maxProfit(self, prices: List[int]) -> int:
maxProfit = 0
for i in range(1,len(prices)):
if(prices[i-1]<prices[i]):
maxProfit = maxProfit + prices[i] - prices[i-1]
return maxProfit
LeetCode:123. 买卖股票的最佳时机 III
给定一个数组,它的第 i 个元素是一支给定的股票在第 i 天的价格。
设计一个算法来计算你所能获取的最大利润。你最多可以完成 两笔 交易。
注意: 你不能同时参与多笔交易(你必须在再次购买前出售掉之前的股票)。
示例 1:
输入: [7,1,5,3,6,4]
输出: 7解释: 在第 2 天(股票价格 = 1)的时候买入,在第 3 天(股票价格 = 5)的时候卖出, 这笔交易所能获得利润 = 5-1 = 4 。
随后,在第 4 天(股票价格 = 3)的时候买入,在第 5 天(股票价格 = 6)的时候卖出, 这笔交易所能获得利润 = 6-3 = 3 。
示例 2:
输入: [1,2,3,4,5]
输出: 4解释: 在第 1 天(股票价格 = 1)的时候买入,在第 5 天 (股票价格 = 5)的时候卖出, 这笔交易所能获得利润 = 5-1 = 4 。
注意你不能在第 1 天和第 2 天接连购买股票,之后再将它们卖出。因为这样属于同时参与了多笔交易,你必须在再次购买前出售掉之前的股票。
示例 3:
输入: [7,6,4,3,1] 输出: 0 解释: 在这种情况下, 没有交易完成, 所以最大利润为 0。
解题思路:
- 典型的动态规划解法—三维数组的解法:
如果我们把买+卖算一次交易,那么这道题的限制是交易数,天数,手上有没有股票(有股票就不能买,没有股票就不能卖)
首先定义一个状态方程,建立一个三维的数组:dp。
- dp[i][j][0] 今天是第i天,进行j次交易了,手上没有股票,
- dp[i][j][1] 今天是第i天,进行j次交易,手上有股票。
- dp是求无论手上有没有股票,最后的最大利润。所以最后如果股票全都卖出去了,肯定能获得最大利润啦。即dp[-1][j][0]。
状态转移:
- dp[i][j][0] = max(dp[i-1][j][0], dp[i-1][j][1] + prices[i])
- dp[i][j][1] = max(dp[i-1][j][1], dp[i-1][j-1][0] - prices[i])
dp[i][j][0]表示当前手上没有股票,这样的状态可以由两个状态转移得来:前一天没有股票,即dp[i-1][j][0]和前一天手上有股票,但卖出去了,即dp[i-1][j][1] + prices[i]这里需要+ prices[i]因为卖出股票会有收益。
同理,dp[i][j][1] 可以由:dp[i-1][j][1]和前一天没有股票但前一天买入了,即dp[i-1][j-1][0] - prices[i]转移。
- Python代码如下:
class Solution:
def maxProfit(self, prices: List[int]) -> int:
# 2笔
# 定义卖出股票,交易次数 j + 1
#dp[i][j][0] 今天是第i天 进行 j次 交易 手上没有股票
#dp[i][j][1] 今天是第i天 进行 j次 交易 手上有股票
if not prices: return 0
n = len(prices)
dp = [[[0] * 2 for _ in range(3)] for _ in range(n)]
for k in range(3): #base case i=0
dp[0][k][0] = 0
dp[0][k][1] = -prices[0]
for i in range(1, n):
for j in range(3):
if not j:
dp[i][j][0] = dp[i-1][j][0] # 0 base case j=0
else:
dp[i][j][0] = max(dp[i-1][j][0], dp[i-1][j-1][1] + prices[i])
dp[i][j][1] = max(dp[i-1][j][1], dp[i-1][j][0] - prices[i])
return max(dp[-1][0][0], dp[-1][1][0], dp[-1][2][0])
转换成一维数组形式:
class Solution:
def maxProfit(self, prices: List[int]) -> int:
if len(prices)<1:
return 0
if len(prices)//2 <= 2:
maxProfit = 0
for i in range(1,len(prices)):
if(prices[i-1]<prices[i]):
maxProfit+=prices[i]-prices[i-1]
return maxProfit
dp = [0]*(3)
v = [prices[0]]*(3)
for i in range(1,len(prices)):
for t in range(1,3):
v[t] = min(v[t], prices[i] - dp[t - 1])
dp[t] = max(dp[t], prices[i] - v[t])
return dp[2]
LeetCode 188. 买卖股票的最佳时机 IV
给定一个数组,它的第 i 个元素是一支给定的股票在第 i 天的价格。
设计一个算法来计算你所能获取的最大利润。你最多可以完成 k 笔交易。
**注意: **你不能同时参与多笔交易(你必须在再次购买前出售掉之前的股票)。
示例 1:
输入: [2,4,1], k = 2
输出: 2解释: 在第 1 天 (股票价格 = 2) 的时候买入,在第 2 天 (股票价格 = 4) 的时候卖出,这笔交易所能获得利润 = 4-2 = 2 。
示例 2:
输入: [3,2,6,5,0,3], k = 2
输出: 7解释: 在第 2 天 (股票价格 = 2) 的时候买入,在第 3 天 (股票价格 = 6) 的时候卖出, 这笔交易所能获得利润 = 6-2 = 4 。
随后,在第 5 天 (股票价格 = 0) 的时候买入,在第 6 天 (股票价格 = 3) 的时候卖出, 这笔交易所能获得利润 = 3-0 = 3 。
解题思路和第三题类似:
Python代码实现(用一维数组表示):
class Solution:
def maxProfit(self, k: int, prices: List[int]) -> int:
if len(prices)<1:
return 0
if len(prices)//2 <= k:
maxProfit = 0
for i in range(1,len(prices)):
if(prices[i-1]<prices[i]):
maxProfit+=prices[i]-prices[i-1]
return maxProfit
dp = [0]*(k+1)
v = [prices[0]]*(k+1)
for i in range(1,len(prices)):
for t in range(1,k+1):
v[t] = min(v[t], prices[i] - dp[t - 1])
dp[t] = max(dp[t], prices[i] - v[t])
return dp[k]
- C++实现:
class Solution {
public:
int maxProfit(int k, vector<int>& prices) {
if(!prices.size()) return 0;
if(k >= prices.size()/2)
{
int maxsumval = 0;
for(int i = 1; i < prices.size(); i++)
if(prices[i] > prices[i - 1])
maxsumval += prices[i] - prices[i - 1];
return maxsumval;
}
vector<int> dp(k + 1, 0);
vector<int> v(k + 1, prices[0]);
for(int i = 1; i < prices.size(); i++)
{
for(int t = 1; t <= k; t++)
{
v[t] = min(v[t], prices[i] - dp[t - 1]);
dp[t] = max(dp[t], prices[i] - v[t]);
}
}
return dp[k];
}
};